// *************************************************
// Script for EasyJobApplication Extension
// Author: Carlos Eugnio Torres
// Email: carloseugeniotorres@gmail.com
// Website: http://www.carloseugeniotorres.com
// Version: 1.2
// last version date: 31/01/2007
// 1st version date: 05/08/2006
// *************************************************

// Globals
var _debug = true;
var _subject;
var _body;
var _opennewwindow;
var _directsend;
var _doctitleinsubject;
var _usehttps;
var _usehtml;
const prefPrefix = "easyjobapplication.";
const propertiesPath = "chrome://easyjobapplication/locale/easyjobapplication.properties";
var copiedEmailAddress = "";
const gmailUrl_const = "://mail.google.com/mail/?view=cm&fs=1&tf=1&su=[subject]&body=[body]&to=[to]";
var _emailSubject;
var _emailbody;
var _emailTo;
var _confirmmessage;
var _controlKeyPressed = false;

/**
 * Util
 */
function getPlatform() 
{
	return Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo).name;
}
function debug(msg) 
{
	if (_debug)
	{
		var consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
		consoleService.logStringMessage(msg);
	}
}
function ejaPrompt(title, msg, defVal) 
{
	var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
	var result = {value:defVal};
	if (promptService.prompt(null, title, msg, result, null, {value:0})) 
		return result.value;
	else 
		return null;
}
/**
 * Gmail sign in
 */
function isLogged() 
{
	return getCookie("google.com", "SID")? true : false;
}

function getCookie(cookieHost, cookieName) 
{
	var cookies = Components.classes["@mozilla.org/cookiemanager;1"]
							.getService(Components.interfaces.nsICookieManager)
							.enumerator;
	while (cookies.hasMoreElements()) {
		var cookie = cookies.getNext();
		if (cookie instanceof Components.interfaces.nsICookie) {
			if (cookie.host.indexOf(cookieHost)>-1 && cookie.name==cookieName) {
				return cookie;
			}
		}
	}
	return null;
}	

/**
 * String bundle
 */
function getBundle() 
{
  return Components.classes["@mozilla.org/intl/stringbundle;1"]
           .getService(Components.interfaces.nsIStringBundleService)
           .createBundle(propertiesPath);
}

function getBundleString(aName) 
{
  return getBundle().GetStringFromName(aName);
}

function getBundleFString(aName, aParams) 
{
  return getBundle().formatStringFromName(aName, aParams, aParams.length);
}

// Add init function to load event
window.addEventListener("load", init, false);

function init()
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranchInternal);
	prefs.addObserver(prefPrefix, gEJAPrefChangedObserver, false);
	window.addEventListener("unload", EJAUnload, false);
	rightClickListener();
}

var gEJAPrefChangedObserver = 
{
  observe: function(aSubject, aTopic, aPrefName)
  {
    if (aTopic != "nsPref:changed")
      return;

    if (aPrefName.indexOf(prefPrefix) > -1)
    {
		window.setTimeout(this.ReloadPreferences, 100);
    }
  },

  ReloadPreferences: function()
  {
	loadPrefs();
  }
}

function loadPrefs()
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
	prefs = prefs.getBranch(prefPrefix);
	_subject = prefs.getComplexValue("subject",Components.interfaces.nsISupportsString).data;
	_body = prefs.getComplexValue("body",Components.interfaces.nsISupportsString).data;
	_opennewwindow = prefs.getBoolPref("opennewwindow");
	_doctitleinsubject = prefs.getBoolPref("doctitleinsubject");
	_usehttps = prefs.getBoolPref("usehttps");
	_usehtml = prefs.getBoolPref("usehtml");
	_directsend = prefs.getBoolPref("directsend");
	_confirmmessage = prefs.getBoolPref("confirmmessage");
}

function EJAUnload()
{
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranchInternal);
	prefs.removeObserver(prefPrefix, gEJAPrefChangedObserver);
}

// Add listener for right click
function rightClickListener()
{
	var menu = document.getElementById("contentAreaContextMenu");
	menu.addEventListener("popupshowing",contextPopupShowing,false);
}
function contextPopupShowing()
{
	try
	{
		var isTextSelected = false;
		if(gContextMenu)
		{
			isTextSelected = gContextMenu.isTextSelected;
		}
		
		// Verify if the selected text is an email
		copiedEmailAddress = getSelectedText(" ");
		var isTextSelectedEmail = false;
		var emailFilter  = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
		isTextSelectedEmail = emailFilter.test(copiedEmailAddress);

		var txt;

		var menuitemlinkSelected = document.getElementById("easyjobapplication-contextmenu-selectedtext");
		if(menuitemlinkSelected)
		{
			txt = getBundleString("menuitem-send-to-selected-text") + "";
			menuitemlinkSelected.label = txt.replace("%S","\""+copiedEmailAddress+"\"");
			menuitemlinkSelected.accesskey = getBundleString("menuitem-send-to-selected-text-accesskey");
			menuitemlinkSelected.hidden = (!isTextSelected || !isTextSelectedEmail);
		}

		var menuitemlinkSelectedCustomSubject = document.getElementById("easyjobapplication-contextmenu-selectedtext-custom-subject");
		if(menuitemlinkSelectedCustomSubject)
		{
			txt = getBundleString("menuitem-send-to-selected-text-custom-subject") + "";
			menuitemlinkSelectedCustomSubject.label = txt.replace("%S","\""+copiedEmailAddress+"\"");
			menuitemlinkSelectedCustomSubject.accesskey = getBundleString("menuitem-send-to-selected-text-custom-subject-accesskey");
			menuitemlinkSelectedCustomSubject.hidden = (!isTextSelected || !isTextSelectedEmail);
		}

		var isMailtoLink = false;
		if (gContextMenu)
		{
			isMailtoLink = gContextMenu.onMailtoLink;
		}
		var menuitemlink = document.getElementById("easyjobapplication-contextmenu");
		if(menuitemlink)
		{
			menuitemlink.hidden = (!isMailtoLink || !menuitemlinkSelected.hidden);
		}
		var menuitemlinkCustomSubject = document.getElementById("easyjobapplication-contextmenu-custom-subject");
		if(menuitemlinkCustomSubject)
		{
			menuitemlinkCustomSubject.hidden = (!isMailtoLink || !menuitemlinkSelected.hidden);
		}
	}
	catch (e)
	{
		alert("Error on showing menu: " + e)
	}
}

function replaceText(inString,oldText,newText) 
{
	return (inString.split(oldText).join(newText));
}

// Open Gmail to send job application to mailto: link
function sendFromRightClick(customSubject)
{
	loadPrefs();
	copiedEmailAddress = "";
	var docTitle = "";
	
	if (_doctitleinsubject)
		docTitle = content.document.title;
		
	var elem = document.popupNode;
	if(elem) 
	{
		if(elem instanceof Components.interfaces.nsIDOMHTMLAnchorElement && elem.href)
		{
			copiedEmailAddress = elem.href.toString();
		}
		else
		{
			copiedEmailAddress = elem.parentNode.toString();
		}
	}

	copiedEmailAddress = replaceText(copiedEmailAddress, "mailto:", "");
	
	// Test if there is subject information in mailto link
	// If it has, use it as subject
	if (copiedEmailAddress.indexOf("subject") > -1)
	{
		copiedEmailAddress += "&";
		_subject = _subject + " " + unescape(copiedEmailAddress.split(/\?subject=(.*)\&/gi)[1]);
		copiedEmailAddress = copiedEmailAddress.split(/(.*)\?subject/gi)[1];
	}
	else
	{
		_subject += " " + docTitle;
	}

	try
	{
		if (customSubject)
		{
			aux = ejaPrompt("Easy Job Application", getBundleString("new-subject-prompt"), _subject);
			_subject = aux != null ? aux : _subject;
		}
	}
	catch (e)
	{
		alert("Error on prompting for custom subject: " + e);
	}

	_emailTo = copiedEmailAddress;
	openEmail();
}

// Open Gmail to send job application to selected text email
function sendFromSelectedText(customSubject)
{
	loadPrefs();
	copiedEmailAddress = "";
	var docTitle = "";
	if (_doctitleinsubject)
		docTitle = content.document.title;

	_subject += " " + docTitle;
	copiedEmailAddress = getSelectedText(" ");
	_emailTo = copiedEmailAddress;
	try
	{
		if (customSubject)
		{
			aux = ejaPrompt("Easy Job Application", getBundleString("new-subject-prompt"), _subject);
			_subject = aux != null ? aux : _subject;
		}
	}
	catch (e)
	{
		alert("Error on prompting for custom subject: " + e);
	}
	openEmail();
}

function openEmail()
{
	// Check if user is signed in Gmail
	if (!isLogged()) 
	{
		if (confirm(getBundleFString("sign-in-question",[getPlatform()])))
		{
			window.open("chrome://easyjobapplication/content/login.xul",
						"login", "chrome,dialog,centerscreen,dependent");
		}
	}
	else
	{
		window.setTimeout("openEmail2()",100);
	}
}

function openEmail2()
{
	if (_directsend) // send email directly
	{
		try
		{
			var base = "";
			var labels = [];
			var action = function(r) {
				var pattern = "<option\\s+value=[\"']ac_(.+?)[\"']";
				var p1 = new RegExp(pattern, "gi");
				var p2 = new RegExp(pattern, "i");
				var matches = r.responseText.match(p1);
				for (var i=0; i<matches.length/2; i++) {
					var submatches = matches[i].match(p2);
					labels.push([new XMLHttpRequest(), encodeURI(submatches[1])]);
				}
				labels.push([new XMLHttpRequest(), ""]);

				var matches = r.responseText.match(/<base\s+href=["'](.+?)["']/i);
				base = matches[1];
			}
			EJA_Connection.makeRequest(null, "GET", GMAIL_PAGE, action, null, true);

			content.window.status = getBundleString("message-sending") + " \"" + _emailTo + "\"...";

			action = function(request) {
				var doc = request.responseText;
				var matches = doc.match(/Your message has been sent/i); ///<meta.+?content\s*=\s*".*?url='(.+?)'/i
				content.window.status = "";
				if (matches) {
					if (_confirmmessage)
						alert(getBundleString("message-sent")+"");
					else
						content.window.status = getBundleString("message-sent")+"";
				} else {
					if (_confirmmessage)
						alert(getBundleString("message-not-sent")+"");
					else
						content.window.status = getBundleString("message-sent")+"";
				}
			}
			var cookie = getCookie("google.com", "GMAIL_AT");
			var url = base + "?v=b&fv=b&cpt=c&pv=tl&cs=c&at=" + cookie.value;
			var contents = [["redir", "?"],
							["to", _emailTo],
							["subject", _subject],
							["body", _body],
							["nvp_bu_send", "Send"]
							];
			EJA_Connection.makeRequest(null, "POST", url, action, contents);
		}
		catch (e)
		{
		}
	}
	else // open compose window
	{
		var gmailUrl = (_usehttps ? "https" : "http") + gmailUrl_const;
		/*
		if (_usehtml)
		{
			_body = _body.replace(/\n/g,"<br>");
		}
		*/
		gmailUrl = gmailUrl.replace("[subject]",encodeURIComponent(_subject));
		gmailUrl = gmailUrl.replace("[body]",encodeURIComponent(_body));
		gmailUrl = gmailUrl.replace("[to]",encodeURIComponent(_emailTo));

		debug("gmailUrl: " + gmailUrl);

		var container;
		if (!_opennewwindow) 
		{
			container = gBrowser.addTab(gmailUrl);
			gBrowser.selectedTab = container;
		}
		else 
		{
			var width = 500;
			var height = 600;
			var left = Math.floor( (screen.width - width) / 2);
			var top = Math.floor( (screen.height - height) / 2);
			window.open(gmailUrl,"ejaEmailWindow","width="+width+",height="+height+",left="+left+",top="+top+",resizable=1,scrollbars=0");
		}
	}
}

function getSelectedText(concationationChar)
{
    var node = document.popupNode;
    var selection = "";

    if ((node instanceof HTMLTextAreaElement) || (node instanceof HTMLInputElement && node.type == "text"))
	{
        selection = node.value.substring(node.selectionStart, node.selectionEnd);
    } 
    else
	{
        var focusedWindow = new XPCNativeWrapper(document.commandDispatcher.focusedWindow, 'document', 'getSelection()');
        selection = focusedWindow.getSelection().toString();
    }

    // Limit length to 150 to optimize performance. Longer does not make sense
    if (selection.length>=150)
	{
        selection = selection.substring(0, 149);
    }
	// Strip newlines
    selection = selection.replace(/(\n|\r|\t)+/g, " ");
    // Strip spaces at start and end.
    selection = selection.replace(/(^\s+)|(\s+$)/g, "");

    selection = selection.split(" ");
   
    // Remove certain characters at the beginning and end of every word
    for (i=0; i<selection.length; i++)
	{
        selection[i]=selection[i].replace(/^(\&|\(|\)|\[|\]|\{|\}|"|,|\.|!|\?|'|:|;)+/, "");
        selection[i]=selection[i].replace(/(\&|\(|\)|\[|\]|\{|\}|"|,|\.|!|\?|'|:|;)+$/, "");
    }   

    selection = selection.join(concationationChar);   
    return selection; 
}

function showSettingsWindow()
{
	window.open("chrome://easyjobapplication/content/easyjobapplication-settings.xul",
						"eja-settings", "chrome,dialog,centerscreen,dependent");
}